// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_records.sql

package queries

import (
	"context"
	"net/netip"

	"github.com/gofrs/uuid"
	"github.com/jackc/pgx/v5/pgtype"
)

const listRecords = `-- name: ListRecords :many

SELECT
    id,
    group_id,
    correlation_id,

    -- Actor
    actor_type,
    actor_user_name,
    actor_user_email,
    actor_service_subject_common_name,
    actor_service_public_key_thumbprint,

    -- Event
    event_type,
    event_contract_content_hash,
    event_service_name,
    event_failed_distribution_retry_content_hash,
    event_failed_distribution_retry_peer_id,
    event_failed_distribution_retry_action,
    event_peer_id,

    -- Source
    source_type,
    source_http_ip_address,
    source_http_user_agent,

    -- Status
    status_type,
    status_error,

    component,
    under_review_at,
    created_at
FROM auditlog.records as r
WHERE
    r.group_id = $2::text
    AND (cardinality($3::uuid[]) = 0 OR r.id = ANY($3::uuid[]))
    AND (cardinality($4::uuid[]) = 0 OR r.correlation_id = ANY($4::uuid[]))
    AND (cardinality($5::text[]) = 0 OR r.event_contract_content_hash = ANY($5::text[]) OR r.event_failed_distribution_retry_content_hash = ANY($5::text[]))
    AND (cardinality($6::text[]) = 0 OR r.event_service_name = ANY($6::text[]))
    AND ($7::timestamp IS NULL OR r.created_at >= $7::timestamp)
    AND ($8::timestamp IS NULL OR r.created_at <= $8::timestamp)
    AND ($9::bool = false OR r.under_review_at IS NOT NULL)
    AND ($10::uuid = '00000000-0000-0000-0000-000000000000'
        OR ($11::text = 'asc' AND r.id > $10::uuid)
        OR ($11::text = 'desc' AND r.id < $10::uuid)
    )
ORDER BY
    CASE
        WHEN $11::text = 'asc' THEN r.id END ASC,
    CASE
        WHEN $11::text = 'desc' THEN r.id END DESC
LIMIT $1
`

type ListRecordsParams struct {
	Limit          int32
	GroupID        string
	Ids            []uuid.UUID
	CorrelationIds []uuid.UUID
	ContentHashes  []string
	ServiceNames   []string
	PeriodStart    pgtype.Timestamp
	PeriodEnd      pgtype.Timestamp
	UnderReview    bool
	StartID        uuid.UUID
	OrderDirection string
}

type ListRecordsRow struct {
	ID                                      uuid.UUID
	GroupID                                 string
	CorrelationID                           uuid.UUID
	ActorType                               AuditlogActor
	ActorUserName                           *string
	ActorUserEmail                          *string
	ActorServiceSubjectCommonName           *string
	ActorServicePublicKeyThumbprint         *string
	EventType                               AuditlogEvent
	EventContractContentHash                *string
	EventServiceName                        *string
	EventFailedDistributionRetryContentHash *string
	EventFailedDistributionRetryPeerID      *string
	EventFailedDistributionRetryAction      NullAuditlogFailedDistributionRetryAction
	EventPeerID                             *string
	SourceType                              AuditlogSource
	SourceHttpIpAddress                     *netip.Addr
	SourceHttpUserAgent                     *string
	StatusType                              AuditlogStatus
	StatusError                             *string
	Component                               AuditlogComponent
	UnderReviewAt                           pgtype.Timestamptz
	CreatedAt                               pgtype.Timestamptz
}

// Copyright © VNG Realisatie 2023
// Licensed under the EUPL
func (q *Queries) ListRecords(ctx context.Context, arg *ListRecordsParams) ([]*ListRecordsRow, error) {
	rows, err := q.db.Query(ctx, listRecords,
		arg.Limit,
		arg.GroupID,
		arg.Ids,
		arg.CorrelationIds,
		arg.ContentHashes,
		arg.ServiceNames,
		arg.PeriodStart,
		arg.PeriodEnd,
		arg.UnderReview,
		arg.StartID,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListRecordsRow{}
	for rows.Next() {
		var i ListRecordsRow
		if err := rows.Scan(
			&i.ID,
			&i.GroupID,
			&i.CorrelationID,
			&i.ActorType,
			&i.ActorUserName,
			&i.ActorUserEmail,
			&i.ActorServiceSubjectCommonName,
			&i.ActorServicePublicKeyThumbprint,
			&i.EventType,
			&i.EventContractContentHash,
			&i.EventServiceName,
			&i.EventFailedDistributionRetryContentHash,
			&i.EventFailedDistributionRetryPeerID,
			&i.EventFailedDistributionRetryAction,
			&i.EventPeerID,
			&i.SourceType,
			&i.SourceHttpIpAddress,
			&i.SourceHttpUserAgent,
			&i.StatusType,
			&i.StatusError,
			&i.Component,
			&i.UnderReviewAt,
			&i.CreatedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
